routes/admin.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\HomeController;
use App\Http\Controllers\Admin\DolenciaController;
use App\Http\Controllers\Admin\PlantaController;
use App\Http\Controllers\Admin\DispositivoController;
use App\Http\Controllers\Admin\LimiteController;
use App\Http\Controllers\Admin\CursoController;
use App\Http\Controllers\Admin\LeccionController;
use App\Http\Controllers\User\UserController;
use App\Http\Controllers\Admin\ConfiguracionController;


Route::get('/', [DolenciaController::class, 'index']);
Route::resource('dolencias', DolenciaController::class)->except(['show']);
Route::resource('plantas', PlantaController::class)->except(['show']);
Route::resource('dispositivos', DispositivoController::class);
Route::resource('limites', LimiteController::class);
Route::resource('cursos', CursoController::class);
Route::resource('lecciones', LeccionController::class);
Route::resource('users', UserController::class);
Route::resource('parametros', ConfiguracionController::class);

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
require 'admin.php';
Route::get('/', function () {
    return view('welcome');
});

app/Models/Curso.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use App\Transformers\CursoTransformer;

class Curso extends Model
{
    use HasFactory,SoftDeletes;

    protected $dates=['delete_at'];
    protected $fillable =[
        'planta_id','titulo','descripcion'
    ];

    protected $hidden = ['created_at','updated_at','deleted_at'];

    public $transformer = CursoTransformer::class;

    public function planta()
    {
        return $this->belongsTo(Planta::class);
    }

    public function lecciones()
    {
        return $this->hasMany(Leccion::class);
    }
}

app/Http/Controllers/Admin/CursoController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Api\ApiController;
use Illuminate\Http\Request;
use App\Models\Planta;
use App\Models\Curso;

class CursoController extends ApiController
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    const INDEX = 'curso.index'; 
    public function index(Request $request)
    {
        //
        $planta = Planta::with('cursos')->findOrFail($request->planta);
        
            if ($request->expectsJson()) {                
                return $this->showOneMany('Datos encontrados', $planta);
            } else {                
                return view('admin.curso.index', compact('planta'));
            }
        
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {
        //
        $planta = Planta::with('cursos')->find($request->input('planta'));
        return view('admin.curso.create',compact('planta'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request,Curso $curso)
    {
        //
        $request->validate([
            'titulo'=> 'required',
            'descripcion'=> 'required',  
            
        ]);

        $curso_nuevo=Curso::create($request->all());
        return redirect()->route(self::INDEX,['planta'=>$curso_nuevo->planta_id])->with('info','Curso agregdo con exito');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request,Curso $curso)
    {
        //
        if ($request->expectsJson()) {
            $curso=Curso::with('planta')->findOrFail($curso->id); 
            return $this->showOne('Dato encontrado',$curso);            
        }
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Curso $curso)
    {
        //
        $planta=Planta::find($curso->planta_id);
        
        return view('admin.curso.edit',compact('curso','planta'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,Curso $curso)
    {
        //
        $request->validate([
            'titulo'=> 'required',
            'descripcion'=> 'required',  
            
        ]);
        $curso->update($request->all());
        return redirect()->route(self::INDEX,['planta'=>$curso->planta_id])->with('info','Curso editado con exito');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Curso $curso)
    {
        //
        $planta_id=$curso->planta_id;
        $curso->delete();
        return redirect()->route(self::INDEX,['planta'=>$planta_id])->with('info','Curso borrado con exito');
    }
}

resources/views/admin/curso/create.blade.php
@extends('adminlte::page')

@section('title', 'Cultivo Urbano IoT')

@section('content_header')

@stop

@section('content')
<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="{{route('dolencias.index')}}">Dolencias</a></li>
      <li class="breadcrumb-item"><a href="{{route('plantas.index', ['dolencia'=>$planta->dolencia_id])}}">Plantas</a></li>
      <li class="breadcrumb-item"><a href="{{route('cursos.index', ['planta'=>$planta->id])}}">Cursos</a></li>
      <li class="breadcrumb-item active" aria-current="page">Crear</li>
    </ol>
  </nav>

    <div class="container">
        <div class="card">
            <div class="card-body">
                {!!Form::open(['route'=>'cursos.store'])!!}
                {!!Form::hidden('planta_id',$planta->id)!!}
                <div class="form-group">
                    {!! Form::label('name', 'Titulo') !!}
                    {!! Form::text('titulo', null, ['class' => 'form-control']) !!}
                    @error('titulo')
                        <span class="text-danger">{{$message}}</span>
                    @enderror
                </div>
                <div class="form-group">
                    {!! Form::label('name', 'Descripción') !!}
                    {!! Form::textarea('descripcion', null, ['class' => 'form-control']) !!}
                    @error('description')
                        <span class="text-danger">{{$message}}</span>
                    @enderror
                </div>
                
                {!! Form::submit('Guardar', ['class'=>'btn btn-primary']) !!}
                {!!Form::close([])!!}
            </div>
        </div>
    </div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

resources/views/admin/curso/edit.blade.php
@extends('adminlte::page')

@section('title', 'Cultivo Urbano IoT')

@section('content_header')

@stop

@section('content')
<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="{{route('dolencias.index')}}">Dolencias</a></li>
      <li class="breadcrumb-item"><a href="{{route('plantas.index', ['dolencia'=>$planta->dolencia_id])}}">Plantas</a></li>
      <li class="breadcrumb-item"><a href="{{route('cursos.index', ['planta'=>$curso->planta_id])}}">Curso</a></li>
      <li class="breadcrumb-item active" aria-current="page">Editar</li>
    </ol>
  </nav>

    <div class="container">
        <div class="card">
            <div class="card-body">
                {!!Form::model($curso,['route'=>['cursos.update',$curso],'method'=>'put'])!!}                
                <div class="form-group">
                    {!! Form::label('name', 'Caracteristica') !!}
                    {!! Form::text('titulo', null, ['class' => 'form-control']) !!}
                    @error('titulo')
                        <span class="text-danger">{{$message}}</span>
                    @enderror
                </div>
                <div class="form-group">
                    {!! Form::label('name', 'Descripción') !!}
                    {!! Form::textarea('descripcion', null, ['class' => 'form-control']) !!}
                    @error('description')
                        <span class="text-danger">{{$message}}</span>
                    @enderror
                </div>
                
                {!! Form::submit('Guardar', ['class'=>'btn btn-primary']) !!}
                {!!Form::close([])!!}
            </div>
        </div>
    </div>
@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

resources/views/admin/curso/index.blade.php
@extends('adminlte::page')

@section('title', 'Cultivo Urbano IoT')

@section('content_header')

@stop

@section('content')
<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="{{route('dolencias.index')}}">Dolencias</a></li>
      <li class="breadcrumb-item"><a href="{{route('plantas.index',['dolencia'=>$planta->dolencia_id])}}">Plantas</a></li>
      <li class="breadcrumb-item active" aria-current="page">Curso para {{$planta->nombre}} </li>
    </ol>
  </nav>
                   <!-- Begin Page Content -->
                   <div class="container-fluid">

                    <!-- Page Heading -->
                    
                                 
                    @if(session('info'))            
                    <div class="row" id="alert_box">
                        <div class="col-12">
                            <div class="alert alert-success" role="alert">
                                <strong>{{session('info')}}</strong>
                            </div>
                        </div>
                    </div>
                    @endif

                    <!-- DataTales Example -->
                    <div class="card shadow mb-4">
                        <div class="card-header py-3">
                            <a  class="btn btn-primary" role="button" href="{{route('cursos.create',['planta'=>$planta->id])}}">Crear</a>
                        </div>
                        <div class="card-body">
                            <div class="table-responsive">
                                <table class="table table-bordered" id="dataTable" aria-describedby="Lista de registros de la sección"  >
                                    <thead>
                                        <tr>
                                            <th scope="col">Titulo</th>                                             
                                            <th scope="col">Descripción</th>                                            
                                            <th scope="col">Acciones</th>    
                                        </tr>
                                    </thead>                                  
                                    <tbody>
                                        
                                        @foreach($planta->cursos as $curso)
                                        <tr>
                                            <td>{{$curso->titulo}}</td>
                                            <td>{{$curso->descripcion}}</td>
                                            
                                            <td><div class="acciones">
                                                    <a href ="{{route('lecciones.index',['curso'=>$curso->id])}}" class="tooltipped" data-position="bottom" data-toggle="tooltip" data-placement="top" title="Ver Lecciones" >
                                                        <i class="fas fa-book-reader" aria-hidden="true"></i>                                                   
                                                    </a>
                                                    <a href="{{route('cursos.edit',$curso)}}" class="tooltipped" data-position="bottom" data-toggle="tooltip" data-placement="top" title="Editar " >
                                                        <i class="fa fa-cog" aria-hidden="true"></i>
                                                    </a>                                                   
                                                    <a class="tooltipped" data-position="bottom"data-toggle="tooltip" data-placement="top" title="Eliminar" onclick="showConfirmDeleteModal('{{$curso->titulo}}', '{{route('cursos.destroy',$curso)}}')" >
                                                        <i class="fa fa-trash" aria-hidden="true"></i>
                                                    </a>
                                                </div>
                                            </td>
                                        </tr>  
                                        @endforeach                                        
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>

                </div>
                <!-- /.container-fluid -->

               
                    <!-- Modal -->
                    <div class="modal fade" id="modal1" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLabel">Eliminar</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                            </div>
                            <div class="modal-body">
                                Esta seguro de eliminar el registro <strong><span id="deleteName"></span>. 
                            </div>
                            <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <form method="POST" id="deleteForm" accept-charset="UTF-8" style="display:inline-block">
                                @csrf
                                @method('delete')                    
                                <button type="submit" class="btn btn-danger" value="Confirmar">Confirmar                    
                             </form>
                            </div>
                        </div>
                        </div>
                    </div>


@stop

@section('css')
    <link rel="stylesheet" href="/css/admin_custom.css">
@stop

@section('js')
<script>
    $(document).ready(function() {
        $('#dataTable').DataTable();
    } ); 
    
    @if(session('info'))
    $( "#alert_box" ).fadeOut( 5000, function() {

    });

    @endif

    function showConfirmDeleteModal(name, url) 
        {
            var modal= $('#modal1').modal();       
            console.log(name)
            console.log(url)
            $('#deleteForm').prop('action', url);
            $('#deleteName').text(name);
            modal.modal('show');  
        }
    
    </script>
@stop